<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:06 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/classDoc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/classdoc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/classDoc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a PHP class and provides access to information about the class,
<a name="line22"></a> * the class' comment and tags, and the members of the class. A classDoc only
<a name="line23"></a> * exists if it was processed in this run of PHPDoctor. References to classes
<a name="line24"></a> * which may or may not have been processed in this run are referred to using
<a name="line25"></a> * type (which can be converted to classDoc, if possible).
<a name="line26"></a> *
<a name="line27"></a> * @package PHPDoctor
<a name="line28"></a> */
<a name="line29"></a>class ClassDoc extends ProgramElementDoc
<a name="line30"></a>{
<a name="line31"></a>
<a name="line32"></a>	/** The super class.
<a name="line33"></a>	 *
<a name="line34"></a>	 * @var str
<a name="line35"></a>	 */
<a name="line36"></a>	var $_superclass = NULL;
<a name="line37"></a>
<a name="line38"></a>	/** Is this an interface?
<a name="line39"></a>	 *
<a name="line40"></a>	 * @var bool
<a name="line41"></a>	 */
<a name="line42"></a>	var $_interface = FALSE;
<a name="line43"></a>	
<a name="line44"></a>	/** The class constants.
<a name="line45"></a>	 *
<a name="line46"></a>	 * @var fieldDoc[]
<a name="line47"></a>	 */
<a name="line48"></a>	var $_constants = array();
<a name="line49"></a>	
<a name="line50"></a>	/** The class fields.
<a name="line51"></a>	 *
<a name="line52"></a>	 * @var fieldDoc[]
<a name="line53"></a>	 */
<a name="line54"></a>	var $_fields = array();
<a name="line55"></a>	
<a name="line56"></a>	/** The class methods.
<a name="line57"></a>	 *
<a name="line58"></a>	 * @var methodDoc[]
<a name="line59"></a>	 */
<a name="line60"></a>	var $_methods = array();
<a name="line61"></a>	
<a name="line62"></a>	/** Interfaces this class implements or this interface extends.
<a name="line63"></a>	 *
<a name="line64"></a>	 * @var classDoc[]
<a name="line65"></a>	 */
<a name="line66"></a>	var $_interfaces = array();
<a name="line67"></a>	
<a name="line68"></a>	/** Is this class abstract.
<a name="line69"></a>	 *
<a name="line70"></a>	 * @var bool
<a name="line71"></a>	 */
<a name="line72"></a>	var $_abstract = FALSE;
<a name="line73"></a>	
<a name="line74"></a>	/** Constructor
<a name="line75"></a>	 *
<a name="line76"></a>	 * @param str name Name of this element
<a name="line77"></a>	 * @param RootDoc root The root element
<a name="line78"></a>	 * @param str filename The filename of the source file this element is in
<a name="line79"></a>	 * @param int lineNumber The line number of the source file this element is at
<a name="line80"></a>	 * @param str sourcePath The source path containing the source file
<a name="line81"></a>	 */
<a name="line82"></a>	function classDoc($name, &$root, $filename, $lineNumber, $sourcePath)
<a name="line83"></a>    {
<a name="line84"></a>		$this->_name = $name;
<a name="line85"></a>		$this->_root =& $root;
<a name="line86"></a>		$this->_filename = $filename;
<a name="line87"></a>		$this->_lineNumber = $lineNumber;
<a name="line88"></a>		$this->_sourcePath = $sourcePath;
<a name="line89"></a>	}
<a name="line90"></a>	
<a name="line91"></a>	/** Add a constant to this class.
<a name="line92"></a>	 *
<a name="line93"></a>	 * @param FieldDoc field
<a name="line94"></a>	 */
<a name="line95"></a>	function addConstant(&$constant)
<a name="line96"></a>    {
<a name="line97"></a>        if (!isset($this->_constants[$constant->name()])) {
<a name="line98"></a>            $this->_constants[$constant->name()] =& $constant;
<a name="line99"></a>        }
<a name="line100"></a>	}
<a name="line101"></a>	
<a name="line102"></a>	/** Add a field to this class.
<a name="line103"></a>	 *
<a name="line104"></a>	 * @param FieldDoc field
<a name="line105"></a>	 */
<a name="line106"></a>	function addField(&$field)
<a name="line107"></a>    {
<a name="line108"></a>        if (!isset($this->_fields[$field->name()])) {
<a name="line109"></a>            $this->_fields[$field->name()] =& $field;
<a name="line110"></a>        }
<a name="line111"></a>	}
<a name="line112"></a>	
<a name="line113"></a>	/** Add a method to this class.
<a name="line114"></a>	 *
<a name="line115"></a>	 * @param MethodDoc method
<a name="line116"></a>	 */
<a name="line117"></a>	function addMethod(&$method)
<a name="line118"></a>    {
<a name="line119"></a>        if (isset($this->_methods[$method->name()])) {
<a name="line120"></a>            $phpdoctor =& $this->_root->phpdoctor();
<a name="line121"></a>            echo "\n";
<a name="line122"></a>            $phpdoctor->warning('Found method '.$method->name().' again, overwriting previous version');
<a name="line123"></a>        }
<a name="line124"></a>		$this->_methods[$method->name()] =& $method;
<a name="line125"></a>	}
<a name="line126"></a>	
<a name="line127"></a>	/** Return constants in this class.
<a name="line128"></a>	 *
<a name="line129"></a>	 * @return FieldDoc[]
<a name="line130"></a>	 */
<a name="line131"></a>	function &constants()
<a name="line132"></a>    {
<a name="line133"></a>		return $this->_constants;
<a name="line134"></a>	}
<a name="line135"></a>	
<a name="line136"></a>	/** Return fields in this class.
<a name="line137"></a>	 *
<a name="line138"></a>	 * @return FieldDoc[]
<a name="line139"></a>	 */
<a name="line140"></a>	function &fields()
<a name="line141"></a>    {
<a name="line142"></a>		return $this->_fields;
<a name="line143"></a>	}
<a name="line144"></a>	
<a name="line145"></a>	/** Return a field in this class.
<a name="line146"></a>	 *
<a name="line147"></a>	 * @return FieldDoc
<a name="line148"></a>	 */
<a name="line149"></a>	function &fieldNamed($fieldName)
<a name="line150"></a>    {
<a name="line151"></a>        $return = NULL;
<a name="line152"></a>        if (isset($this->_fields[$fieldName])) {
<a name="line153"></a>            $return =& $this->_fields[$fieldName];
<a name="line154"></a>        }
<a name="line155"></a>        return $return;
<a name="line156"></a>	}
<a name="line157"></a>    
<a name="line158"></a>	/** Return the methods in this class.
<a name="line159"></a>	 *
<a name="line160"></a>	 * @return MethodDoc[]
<a name="line161"></a>	 */
<a name="line162"></a>	function &methods($methodName = NULL)
<a name="line163"></a>    {
<a name="line164"></a>		return $this->_methods;
<a name="line165"></a>	}
<a name="line166"></a>
<a name="line167"></a>	/** Return a method in this class.
<a name="line168"></a>	 *
<a name="line169"></a>	 * @return MethodDoc
<a name="line170"></a>	 */
<a name="line171"></a>	function &methodNamed($methodName)
<a name="line172"></a>    {
<a name="line173"></a>        $return = NULL;
<a name="line174"></a>        if (isset($this->_methods[$methodName])) {
<a name="line175"></a>            $return =& $this->_methods[$methodName];
<a name="line176"></a>        }
<a name="line177"></a>        return $return;
<a name="line178"></a>	}
<a name="line179"></a>    
<a name="line180"></a>	/** Return interfaces implemented by this class or interfaces extended by this interface.
<a name="line181"></a>	 *
<a name="line182"></a>	 * @return ClassDoc[]
<a name="line183"></a>	 */
<a name="line184"></a>	function &interfaces()
<a name="line185"></a>    {
<a name="line186"></a>		return $this->_interfaces;
<a name="line187"></a>	}
<a name="line188"></a>
<a name="line189"></a>	/** Return an interface in this class.
<a name="line190"></a>	 *
<a name="line191"></a>	 * @return ClassDoc
<a name="line192"></a>	 */
<a name="line193"></a>	function &interfaceNamed($interfaceName)
<a name="line194"></a>    {
<a name="line195"></a>        $return = NULL;
<a name="line196"></a>        if (isset($this->_interfaces[$interfaceName])) {
<a name="line197"></a>            $return =& $this->_interfaces[$interfaceName];
<a name="line198"></a>        }
<a name="line199"></a>        return $return;
<a name="line200"></a>	}
<a name="line201"></a>    
<a name="line202"></a>	/** Return true if this class is abstract.
<a name="line203"></a>	 *
<a name="line204"></a>	 * @return bool
<a name="line205"></a>	 */
<a name="line206"></a>	function isAbstract()
<a name="line207"></a>    {
<a name="line208"></a>		return $this->_abstract;
<a name="line209"></a>	}
<a name="line210"></a>
<a name="line211"></a>	/** Return true if this element is an interface.
<a name="line212"></a>	 *
<a name="line213"></a>	 * @return bool
<a name="line214"></a>	 */
<a name="line215"></a>	function isInterface()
<a name="line216"></a>    {
<a name="line217"></a>		return $this->_interface;
<a name="line218"></a>	}
<a name="line219"></a>
<a name="line220"></a>	/** Test whether this class is a subclass of the specified class.
<a name="line221"></a>	 *
<a name="line222"></a>	 * @param ClassDoc cd
<a name="line223"></a>	 * @return bool
<a name="line224"></a>	 */
<a name="line225"></a>	function subclassOf($cd)
<a name="line226"></a>    {
<a name="line227"></a>		if ($this->_superclass == $cd->name()) {
<a name="line228"></a>			return TRUE;
<a name="line229"></a>		} else {
<a name="line230"></a>			return FALSE;
<a name="line231"></a>		}
<a name="line232"></a>	}
<a name="line233"></a>
<a name="line234"></a>	/** Return the superclass of this class.
<a name="line235"></a>	 *
<a name="line236"></a>	 * @return ClassDoc
<a name="line237"></a>	 */
<a name="line238"></a>	function superclass()
<a name="line239"></a>    {
<a name="line240"></a>		return $this->_superclass;
<a name="line241"></a>	}
<a name="line242"></a>	
<a name="line243"></a>	/** Is this construct a class. Note: interfaces are not classes.
<a name="line244"></a>	 *
<a name="line245"></a>	 * @return bool
<a name="line246"></a>	 */
<a name="line247"></a>	function isClass()
<a name="line248"></a>    {
<a name="line249"></a>		return !$this->_interface;
<a name="line250"></a>	}
<a name="line251"></a>	
<a name="line252"></a>	/** Is this construct an ordinary class (not an interface or an exception).
<a name="line253"></a>	 *
<a name="line254"></a>	 * @return bool
<a name="line255"></a>	 */
<a name="line256"></a>	function isOrdinaryClass()
<a name="line257"></a>    {
<a name="line258"></a>		if ($this->isClass() && !$this->isException()) {
<a name="line259"></a>			return TRUE;
<a name="line260"></a>		} else {
<a name="line261"></a>			return FALSE;
<a name="line262"></a>		}
<a name="line263"></a>	}
<a name="line264"></a>
<a name="line265"></a>	/** Is this construct an exception.
<a name="line266"></a>	 *
<a name="line267"></a>	 * @return bool
<a name="line268"></a>	 */
<a name="line269"></a>	function isException()
<a name="line270"></a>    {
<a name="line271"></a>		if (strtolower($this->_superclass) == 'exception') {
<a name="line272"></a>			return TRUE;
<a name="line273"></a>		} else {
<a name="line274"></a>			return FALSE;
<a name="line275"></a>		}
<a name="line276"></a>	}
<a name="line277"></a>    
<a name="line278"></a>
<a name="line279"></a>    /**
<a name="line280"></a>     * Merge the details of the superclass with this class.
<a name="line281"></a>     * @param str superClassName
<a name="line282"></a>     */
<a name="line283"></a>	function mergeSuperClassData($superClassName = NULL)
<a name="line284"></a>    {
<a name="line285"></a>        if (!$superClassName) {
<a name="line286"></a>            $superClassName = $this->superclass();
<a name="line287"></a>        }
<a name="line288"></a>        if ($superClassName) {
<a name="line289"></a>           $parent =& $this->_root->classNamed($superClassName);
<a name="line290"></a>           if ($parent->superclass()) { // merge parents superclass data first by recursing
<a name="line291"></a>               $this->mergeSuperClassData($parent->superclass());
<a name="line292"></a>           }
<a name="line293"></a>        }
<a name="line294"></a>  
<a name="line295"></a>        if (isset($parent)) {
<a name="line296"></a>            $phpdoctor = $this->_root->phpdoctor();
<a name="line297"></a>
<a name="line298"></a>			// merge class tags array
<a name="line299"></a>            $tags =& $parent->tags();
<a name="line300"></a>			if ($tags) {
<a name="line301"></a>				foreach ($tags as $name => $tag) {
<a name="line302"></a>                    if (!isset($this->_tags[$name])) {
<a name="line303"></a>                        $phpdoctor->verbose('> Merging class '.$this->name().' with tags from parent '.$parent->name());
<a name="line304"></a>                        if (is_array($tag)) {
<a name="line305"></a>                            foreach ($tags[$name] as $key => $tag) {
<a name="line306"></a>                                $this->_tags[$name][$key] =& $tags[$name][$key];
<a name="line307"></a>                                $this->_tags[$name][$key]->setParent($this);
<a name="line308"></a>                            }
<a name="line309"></a>                        } else {
<a name="line310"></a>                            $this->_tags[$name] =& $tags[$name];
<a name="line311"></a>                            $this->_tags[$name]->setParent($this);
<a name="line312"></a>                        }
<a name="line313"></a>                    }
<a name="line314"></a>				}
<a name="line315"></a>			}
<a name="line316"></a>            
<a name="line317"></a>            // merge method data
<a name="line318"></a>            $methods =& $this->methods();
<a name="line319"></a>            foreach ($methods as $name => $method) {
<a name="line320"></a>                $parentMethod =& $parent->methodNamed($name);
<a name="line321"></a>                if ($parentMethod) {
<a name="line322"></a>                    // tags
<a name="line323"></a>                    $tags =& $parentMethod->tags();
<a name="line324"></a>                    if ($tags) {
<a name="line325"></a>                        foreach ($tags as $tagName => $tag) {
<a name="line326"></a>                            if (!isset($methods[$name]->_tags[$tagName])) {
<a name="line327"></a>                                $phpdoctor->verbose('> Merging method '.$this->name().':'.$name.' with tag '.$tagName.' from parent '.$parent->name().':'.$parentMethod->name());
<a name="line328"></a>                                if (is_array($tag)) {
<a name="line329"></a>                                    foreach ($tags[$tagName] as $key => $tag) {
<a name="line330"></a>                                        $methods[$name]->_tags[$tagName][$key] =& $tags[$tagName][$key];
<a name="line331"></a>                                        $methods[$name]->_tags[$tagName][$key]->setParent($this);
<a name="line332"></a>                                    }
<a name="line333"></a>                                } else {
<a name="line334"></a>                                    $methods[$name]->_tags[$tagName] =& $tags[$tagName];
<a name="line335"></a>                                    $methods[$name]->_tags[$tagName]->setParent($this);
<a name="line336"></a>                                }
<a name="line337"></a>                            }
<a name="line338"></a>                        }
<a name="line339"></a>                    }
<a name="line340"></a>                    // method parameters
<a name="line341"></a>                    foreach($parentMethod->parameters() as $paramName => $param) {
<a name="line342"></a>                        if (isset($methods[$name]->_parameters[$paramName])) {
<a name="line343"></a>                            $type =& $methods[$name]->_parameters[$paramName]->type();
<a name="line344"></a>                        }
<a name="line345"></a>                        if (!isset($methods[$name]->_parameters[$paramName]) || $type->typeName() == 'mixed') {
<a name="line346"></a>                            $phpdoctor->verbose('> Merging method '.$this->name().':'.$name.' with parameter '.$paramName.' from parent '.$parent->name().':'.$parentMethod->name());
<a name="line347"></a>                            $paramType =& $param->type();
<a name="line348"></a>                            $methods[$name]->_parameters[$paramName] =& new fieldDoc($paramName, $methods[$name], $this->_root);
<a name="line349"></a>                            $methods[$name]->_parameters[$paramName]->set('type', new type($paramType->typeName(), $this->_root));
<a name="line350"></a>                        }
<a name="line351"></a>                    }
<a name="line352"></a>                    // method return type
<a name="line353"></a>                    if ($parentMethod->returnType() && $methods[$name]->_returnType->typeName() == 'void') {
<a name="line354"></a>                        $phpdoctor->verbose('> Merging method '.$this->name().':'.$name.' with return type from parent '.$parent->name().':'.$parentMethod->name());
<a name="line355"></a>                        $methods[$name]->_returnType = $parentMethod->returnType();
<a name="line356"></a>                    }
<a name="line357"></a>                    // method thrown exceptions
<a name="line358"></a>                    foreach($parentMethod->thrownExceptions() as $exceptionName => $exception) {
<a name="line359"></a>                        if (!isset($methods[$name]->_throws[$exceptionName])) {
<a name="line360"></a>                            $phpdoctor->verbose('> Merging method '.$this->name().':'.$name.' with exception '.$exceptionName.' from parent '.$parent->name().':'.$parentMethod->name());
<a name="line361"></a>                            $methods[$name]->_throws[$exceptionName] =& $exception;
<a name="line362"></a>                        }
<a name="line363"></a>                    }
<a name="line364"></a>                }
<a name="line365"></a>            }
<a name="line366"></a>            
<a name="line367"></a>        }
<a name="line368"></a>    }
<a name="line369"></a>
<a name="line370"></a>}
<a name="line371"></a>
<a name="line372"></a>?>
<a name="line373"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/classdoc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>